unit _View_Text;
interface
uses
  Messages,
  ClipBrd,
  Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, Vcl.Dialogs, Vcl.Samples.Spin,
  Buttons, ExtCtrls, ComCtrls, Menus;

type
  TDlg_Text = class(TForm)
    Panel1: TPanel;
    OKBtn: TButton;
    Label_Head: TLabel;
    Panel2: TPanel;
    RE_Text: TRichEdit;
    Timer1: TTimer;
    Panel3: TPanel;
    sb_ToClipboard: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    cb_999: TCheckBox;
    MainMenu1: TMainMenu;
    N1_Edit: TMenuItem;
    N1: TMenuItem;
    N4: TMenuItem;
    Label19: TLabel;
    Label20: TLabel;
    SpinButton2: TSpinButton;
    FontDialog1: TFontDialog;
    Btn_Info_Font: TSpeedButton;
    procedure Timer1Timer(Sender: TObject);
    procedure RE_TextChange(Sender: TObject);
    procedure sb_ToClipboardClick(Sender: TObject);
    procedure cb_999Click(Sender: TObject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure Btn_Info_FontClick(Sender: TObject);
  private
    { Private declarations }

  public
    { Public declarations }
    function Execute(sText:String;sCaption:string='';sHead:string='';YesMaximized:boolean=false):boolean;
  end;


function View_Text(sText:String;sCaption:string='';sHead:string='';YesMaximized:boolean=false):boolean;

implementation

{$R *.dfm}

function View_Text(sText:String;sCaption:string='';sHead:string='';YesMaximized:boolean=false):boolean;
Var
  FormX : TDlg_Text;
begin
  Result:=false;
  FormX:=TDlg_Text.Create(nil);
  TRY
    FormX.N1_Edit.Enabled:=false;
    FormX.cb_999.Visible := false;
    FormX.RE_Text.WordWrap:=true;
    FormX.RE_Text.ReadOnly:=true;
    FormX.OKBtn.Default:=true;
    FormX.RE_Text.ScrollBars:=ssVertical;
    Result:=FormX.Execute(sText,sCaption,sHead,YesMaximized);
  FINALLY
    if FormX<>NIL then begin
       FreeAndNil(FormX);
    end;
  END;
end;

function TDlg_Text.Execute(sText:String;sCaption:string='';sHead:string='';YesMaximized:boolean=false):boolean;
begin
  Result:=false;
  Screen.Cursor:=crHourGlass;
  TRY
    RE_Text.Lines.Text:=sText;
    Label_Head.Caption:=trim(sHead);
    sCaption:=trim(sCaption);
    if length(sCaption)>0 then Caption:=sCaption;
    RE_Text.Color:=clWhite;
    Screen.Cursor:=crDefault;
    if YesMaximized then begin
       Timer1.Enabled:=true;
    end;
    if ShowModal=mrOk then begin
       Result:=true;
    end;
  FINALLY
    Screen.Cursor:=crDefault;
  END;
end;

procedure TDlg_Text.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  WindowState:=wsMaximized;
end;

procedure TDlg_Text.cb_999Click(Sender: TObject);
begin
  if cb_999.Checked then begin
     RE_Text.WordWrap:=true;
     RE_Text.ScrollBars:=ssVertical;
  end
  else begin
     RE_Text.WordWrap:=false;
     RE_Text.ScrollBars:=ssBoth;
  end;
end;

procedure TDlg_Text.RE_TextChange(Sender: TObject);
begin
  RE_Text.Color:=clInfoBk;
end;

procedure TDlg_Text.sb_ToClipboardClick(Sender: TObject);
Var
  Sx:widestring;
begin
  Application.ProcessMessages;
  Screen.Cursor:=crHourGlass;
  TRY
    Sx:=RE_Text.Lines.Text;
    Clipboard.AsText:=Sx;
  FINALLY
    Screen.Cursor:=crDefault;
  END;
end;

procedure TDlg_Text.Btn_Info_FontClick(Sender: TObject);
begin
  FontDialog1.Font:=RE_Text.Font;
  if FontDialog1.Execute then begin
     RE_Text.Font:=FontDialog1.Font;
  end;
end;

procedure TDlg_Text.SpinButton2DownClick(Sender: TObject);
begin
  RE_Text.Font.Size:=RE_Text.Font.Size-1;
end;

procedure TDlg_Text.SpinButton2UpClick(Sender: TObject);
begin
  RE_Text.Font.Size:=RE_Text.Font.Size+1;
end;

end.



